<?php
if (!defined('__TYPECHO_ROOT_DIR__')) exit;
/**
 * typecho分类扩展插件，免费开源，相关文档请移步到听风博客:<a href="https://owoii.com/archives/sortplugin.html" target="_blank">https://owoii.com/archives/sortplugin.html</a>
 * 
 * @package typecho分类扩展插件，免费开源
 * @author 听风
 * @version 1.0.5
 * @link https://owoii.com
 */
class XtMetas_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {    
        
        $db= Typecho_Db::get();
        
        /*先进行查询有没这个字段*/
        try {
            $field = $db->select('count(imglink)')->from('table.metas');
            $isNum = $db->fetchAll($field);
            $totalnum = $isNum[0]['count(`imglink`)'];
        
        } catch (Exception $e) {
            $totalnum = 'no';
        }
        
        if($totalnum=='no'){
            $prefix = $db->getPrefix();
            $db->query("ALTER TABLE `".$prefix."metas` ADD `imglink` VARCHAR(255) DEFAULT '无链接'");
            $db->query("ALTER TABLE `".$prefix."metas` ADD `sortdata` text");
        }
        
        /*增加数据库成功*/
        
        //插件开启，admin/menu.php往添加方法 挂载
        Helper::addPanel(3, 'XtMetas/MetasExtend.php', '分类扩展', '管理分类的扩展插件', 'administrator');
        
        /*添加文章修改分类路由*/
        Helper::addRoute("XtMetas_Action","/XtMetas/Action","XtMetas_Action",'action');
        
        
        
        return '插件开启成功！';
    }
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){
        Helper::removePanel(3, 'XtMetas/MetasExtend.php');
        
        Helper::removeRoute('XtMetas_Action');
        return '已经关闭插件';
    }
    
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form)
    {
        /** 分类名称 */
        $name = new Typecho_Widget_Helper_Form_Element_Text('word', NULL, '百度搜索：听风博客', _t('听风QQ414098151'));
        $form->addInput($name);
        
        $queryBtn = new Typecho_Widget_Helper_Form_Element_Submit();
        $queryBtn->value(_t('查看食用文档'));
        $queryBtn->description(_t('在分类下使用,<span style="color:red">XtMetas_Plugin::imglink(传入mid)</span>获取分类的封面，同理使用<span style="color:red">XtMetas_Plugin::sortdata(传入mid)</span>获取分类的data扩展数据'));
        $queryBtn->input->setAttribute('class', 'btn btn-s btn-warn btn-operate');
        $queryBtn->input->setAttribute('formaction', 'https://owoii.com/archives/sortplugin.html');
        $form->addItem($queryBtn);
    }
    
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 插件实现方法
     * 
     * @access public
     * @return void
     */
    public static function render()
    {
        
    }
    
    /*
    *输出
    */
    
    public static function imglink($obj){
        
        echo('已经废弃');
        
    }
    
    
    public static function sortdata($obj){
        
        echo('已经废弃');
        
    }
    
    
}
